/* 
 FelixMatic
 created by
 Samuele Brunini
 */

#include <LiquidCrystal.h>
#include <EEPROM.h>
#include <Wire.h>
#include <DS1307RTC.h>
#include <TimeLib.h> 
#include <Servo.h>

const char *monthName[12] = {
  "Jan", "Feb", "Mar", "Apr", "May", "Jun",
  "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
};

tmElements_t tm;

Servo servo;

LiquidCrystal lcd(8, A0, 3, 5, 6, 7);

float loadA = 90.8; //variabili per peso
int analogvalA = 66;
float loadB = 213.4; 
int analogvalB = 102;
float analogValueAverage = 0;

long previousMillis = 0;  //timer per aggiornare schemro 
long interval = 1000; 

long previousMillis2 = 0; //timer per erogare cibo
long interval2 = 10; 

long previousMillis3 = 0; //timer per leggere l'ora
long interval3 = 1000; 

long previousMillis4 = 0; //timer per controllo blocco
long interval4 = 4000; 

long previousMillis5 = 0; //timer per controllo blocco
long interval5 = 2000; 

long previousMillis6 = 0; //timer per lampeggio
long interval6 = 500;

long previousMillis7 = 0; //timer per lampeggio
long interval7 = 500;


int mem=0;
int OrePasti[10];
int MinutiPasti[10];
int contatore=0;

int tmp=0;
int pos = 0; 


byte cursoreLCD[8] = {B00000, B00000, B00110, B01111, B01111, B00110, B00000}; // Carattere cursore
byte Freccia[8]  = {B00000, B01110, B01110, B01110, B11111, B01110, B00100};    // Carattere freccia

void setup() {
  Serial.begin(9600);
  collegamento();
  lcd.begin(8, 2);
  lcd.createChar(0, cursoreLCD);
  lcd.createChar(1, Freccia);
  AzzeraPasti();
  inizializza();     
  lcd.setCursor(1,0);
  lcd.print("Felix");
  lcd.setCursor(1,1);
  lcd.print("Matic");
  delay(2500);
  lcd.clear();
}

void loop() {
  char bottone[8] = "null";
  mem=0;
  stampaOra();
  lcd.setCursor(0, 1);
  lcd.print("Premi "); lcd.write(byte(1));
  LeggiOra();
  LeggiBottone(bottone, A2, 200);
  
  if(!strcmp(bottone,"giu"))
    LCDmenu();
  
  if(!strcmp(bottone,"manuale")){
    servo.attach(9);
    servo.write(0);
  }else
    servo.detach();
  
  
}
void stampaOra(){
  lcd.setCursor(0, 0);
  tmElements_t tm;
  unsigned long currentMillis = millis();
  if(currentMillis - previousMillis > interval){
    previousMillis = currentMillis;   
    RTC.read(tm);
    stampa(tm.Hour);
    lcd.print(":");
    stampa(tm.Minute);
    lcd.print(":");
    stampa(tm.Second);
    }
}

void collegamento(){
  bool parse=false;
  bool config=false;

  // get the date and time the compiler was run
  if (getDate(__DATE__) && getTime(__TIME__)) {
    parse = true;
    // and configure the RTC with this info
    if (RTC.write(tm)) {
      config = true;
    }
  }

  Serial.begin(9600);
  while (!Serial) ; // wait for Arduino Serial Monitor
  delay(200);
  if (parse && config) {
    Serial.print("DS1307 configured Time=");
    Serial.print(__TIME__);
    Serial.print(", Date=");
    Serial.println(__DATE__);
  } else if (parse) {
    Serial.println("DS1307 Communication Error :-{");
    Serial.println("Please check your circuitry");
  } else {
    Serial.print("Could not parse info from the compiler, Time=\"");
    Serial.print(__TIME__);
    Serial.print("\", Date=\"");
    Serial.print(__DATE__);
    Serial.println("\"");
  }
  
  }
bool getTime(const char *str)
{
  int Hour, Min, Sec;

  if (sscanf(str, "%d:%d:%d", &Hour, &Min, &Sec) != 3) return false;
  tm.Hour = Hour;
  tm.Minute = Min;
  tm.Second = Sec;
  return true;
}

bool getDate(const char *str)
{
  char Month[12];
  int Day, Year;
  uint8_t monthIndex;

  if (sscanf(str, "%s %d %d", Month, &Day, &Year) != 3) return false;
  for (monthIndex = 0; monthIndex < 12; monthIndex++) {
    if (strcmp(Month, monthName[monthIndex]) == 0) break;
  }
  if (monthIndex >= 12) return false;
  tm.Day = Day;
  tm.Month = monthIndex + 1;
  tm.Year = CalendarYrToTm(Year);
  return true;
}

void AzzeraPasti()
{
  if(EEPROM.read(29)!=0){
    for(int i=0;i<9;i++)
      EEPROM.update(i+20,0);
      EEPROM.write(29,0);
    }
}
void inizializza()
{
  azzera(OrePasti);
  azzera(MinutiPasti);
  carica(OrePasti,1);
  carica(MinutiPasti,10);
  ordina(OrePasti,MinutiPasti);
}
void eroga(){
  float load;
  int analogValue;
  float flag=0;
  contatore=0;
  int val = word(EEPROM.read(19), EEPROM.read(30));
  //Serial.println("Grammi selezionati:");
  //Serial.println(val);
  do
  {    
      analogValue = analogRead(A1);
      analogValueAverage = 0.99*analogValueAverage + 0.01*analogValue;
      unsigned long currentMillis = millis();
    if(currentMillis - previousMillis2 > interval2){
      previousMillis2 = currentMillis;   
      load = analogToLoad(analogValueAverage);
      if(currentMillis - previousMillis5 > interval5){
        previousMillis5 = currentMillis;
        Serial.println("copio flag");
        flag=load;
        }
      if(currentMillis - previousMillis4 > interval4){
        previousMillis4 = currentMillis;   
        Serial.println("controllo se blocca");
        if(load<=flag+1 && load>=flag-1)
          sblocca();
          if(contatore>=5){
            servo.detach();
            lcd.clear();
            lcd.setCursor(1,0);
            lcd.print("ERRORE");
            lcd.setCursor(0,1);
            lcd.print("!!!!!!!!");
            while(1){}
            }
      }
      //Serial.println(load,2);
      servo.attach(9);
      servo.write(0);
    }
  }while(load <= val);
  servo.detach();
  
}
float analogToLoad(float analogval)
{
  float load = mapfloat(analogval, analogvalA, analogvalB, loadA, loadB);
  return load;
}
float mapfloat(float x, float in_min, float in_max, float out_min, float out_max)
{ //utilizza questa map perchè la map normale funziona solo con INT
  return (x- in_min) * (out_max - out_min) / (in_max - in_min) + out_min;
}
void LeggiBottone(char *bottone, int pin, int pausa)
{
  int data = analogRead(pin);

  
    if (data>= 0 && data<= 5)
      strcpy(bottone,"giu");
    else if (data>= 324 && data<= 327)
      strcpy(bottone,"ok");
    else if (data>= 492 && data<= 494)
      strcpy(bottone,"decr");
    else if (data>= 597 && data<= 600)
      strcpy(bottone,"incr");
    else if (data>= 665 && data<= 672)
      strcpy(bottone,"manuale");
      
    delay(pausa);
  
}
void MuoviCursore(int *pos, int max, char ope)
{
  // se viene passato "m" viene sommato 1

  if(ope == 'm')
    if(*pos < max)  *pos += 1;
    else      
      *pos = 0;

  lcd.setCursor(0, 0); lcd.print(" ");
  lcd.setCursor(0, 1); lcd.print(" ");
}
void stampa(int number) //se il numero è a una cifra sola viene aggiunto uno zero prima di esso
{ 
  if (number >= 0 && number < 10) {
    lcd.print('0');
  }
  lcd.print(number);
}
void azzera(int arr[])
{
  for(int i=0;i<9;i++)
    arr[i]=0;
  }
void carica(int ar[],int p)  //carica le ore e i minuti nell'array, riceve ar[] == array e p == posizione del primo elemento nella eeprom 
{
  for(int i=0;i<EEPROM.read(0);i++){
    ar[i]=EEPROM.read(i+p);
  }
}  
/*void stampa()
{
  for(int i=0;i<EEPROM.read(0);i++){
    Serial.print(OrePasti[i]);
    Serial.print(":");
    Serial.println(MinutiPasti[i]);
  }
}  */
void ordina(int a[],int b[]) 
{
  int n = EEPROM.read(0); boolean ordinato = false;
  for (int i=0; i<n-1 && !ordinato; i++) 
  {
    ordinato = true;
    for (int j=n-1; j>i; j--)
      if (a[j-1] > a[j]) 
      {
      int aux = a[j-1];
      int aux2 = b[j-1];
      
      a[j-1] = a[j];
      a[j] = aux;

      b[j-1] = b[j];
      b[j] = aux2;
      ordinato=false;
      }
  }
  for(int i=1;i<EEPROM.read(0);i++){
    int tmp,tmp2;
    if(a[i-1]==a[i]){
      if(b[i-1]>b[i])
        tmp=a[i];
        b[i]=b[i-1];
        b[i-1]=tmp;
      }
  }
  
}
void LeggiOra()
{
  tmElements_t tm;
  unsigned long currentMillis = millis();
  if(currentMillis - previousMillis3 > interval3) 
  {
    previousMillis3 = currentMillis;   
    RTC.read(tm);
    
    for(int i=0;i<EEPROM.read(0);i++) //scorro numeri da 0 a numero di pasti selezionati 
    {
   
      if(OrePasti[i]==tm.Hour && MinutiPasti[i]==tm.Minute){ //se un orario coincide 
        if(EEPROM.read(i+20)!=1)  // se non ha ancora magiato eroga cibo
        {
          Serial.println("Figataaa erogo la pappaa");
          eroga();
          EEPROM.write(i+20,1); //scrivo che ha mangiato in eeprom
        }
      }
     }
    if(tm.Hour==0 && tm.Minute==0)  //se è mezzanotte azzera i pasti
    {
      EEPROM.write(29,1);
      AzzeraPasti();
    }
    Serial.print(tm.Hour);
    Serial.print(":");
    Serial.print(tm.Minute);
    Serial.print(":");
    Serial.println(tm.Second);
  }
} 
void sblocca(){
  Serial.println("SBLOCCAAAAAA");
  servo.write(90);
  delay(1000);
  servo.write(0);
  contatore++;
  }

//-----------------------------------Funzioni Menu------------------------------

void LCDmenu()
{
  char bottone[8];
  int posCursor=0, opcMenu=-2, a=0,b=0;
  
  lcd.clear();
  lcd.setCursor(2, 0); lcd.print("Pasti");
  lcd.setCursor(2, 1); lcd.print("Grammi");

  do{
    strcpy(bottone,"null");
    LeggiBottone( bottone, A2, 200);

    // cursore
    lcd.setCursor(0, posCursor); lcd.write(byte(0));

    if(!strcmp(bottone,"giu")) // somma una posizione al cursore
      MuoviCursore(&posCursor, 2, 'm');
    else if(!strcmp(bottone,"ok"))
      opcMenu = posCursor;  
    
    if(a != 2)
      if(posCursor==2){
        lcd.clear();
        lcd.setCursor(2, 0); lcd.print("Grammi");
        lcd.setCursor(2, 1); lcd.print("Back");
        a=2;
        b=0;
      }
    
    if(posCursor != 2){
      a=posCursor;
      if(b !=2){
        lcd.clear();
        lcd.setCursor(2, 0); lcd.print("Pasti");
        lcd.setCursor(2, 1); lcd.print("Grammi");
        b=2;
       }
    }
    
    switch( opcMenu )
    {
      case 0:       
        numero(); 
        opcMenu = -1;
      break;
      case 1:       
        grammi();
        opcMenu = -1;
      break;
      case 2:       
        lcd.clear();
        opcMenu = -1;
      break;
    };
  }
  while(opcMenu != -1);
  
}

void numero()
{ 
  char bottone[8];
  int posCursor=0, opcMenu=-2; 
  int num=1;
  
  lcd.clear();
  lcd.setCursor(2, 0); lcd.print("n: ");
  lcd.setCursor(5, 0); lcd.print(num);
  lcd.setCursor(2, 1); lcd.print("Back");

  do{
    strcpy(bottone,"null");
    LeggiBottone( bottone, A2, 200);

    lcd.setCursor(0, posCursor); lcd.write(byte(0));

    if(!strcmp(bottone,"giu")) 
      MuoviCursore(&posCursor, 1, 'm');

    else if(!strcmp(bottone,"ok")||!strcmp(bottone,"incr")||!strcmp(bottone,"decr"))
      opcMenu = posCursor;
    switch( opcMenu )
    {
      case 0:
        if(!strcmp(bottone,"incr"))   
        {
          num=num+1;
          if(num >= 10)
            num--;
          lcd.setCursor(5, 0); lcd.print(num);
          
        }
        else if( !strcmp(bottone,"decr") ) 
        {
          num=num-1;
          if (num <= 0)
            num++;
          lcd.setCursor(5, 0); lcd.print(num);
        }
        else if( !strcmp(bottone,"ok") ){
          EEPROM.update(0,num);
          for(int i=0;i<EEPROM.read(0);i++)//ripete ciclo setora per umero di volte di pasti selezionati
            SetOra(i);
          salva();
        }
        if(mem != 1)
           opcMenu = -2;
        else{       //quando ho selezionato il numeri di pasti reinizializzo gli array
          opcMenu = -1;
          inizializza();
          EEPROM.write(29,1);
          AzzeraPasti();
        }
      break;

      case 1:
        if(!strcmp(bottone,"ok"))
          opcMenu = -1;
      break;
    };
  }while(opcMenu != -1);
  
}

void grammi()
{
  char bottone[8];
  int posCursor=0, opcMenu=-2; 
  int grammi = word(EEPROM.read(19), EEPROM.read(30));
  int a=0,b=0,c=0;
  lcd.clear();

  lcd.setCursor(1,0);
  lcd.print("Imposta");
  lcd.setCursor(2, 1);lcd.print("  g");  
  lcd.setCursor(1, 1); lcd.print(grammi);
  lcd.setCursor(6, 1); lcd.print("ok");
    
  do{
    strcpy(bottone,"null");
    LeggiBottone( bottone, A2, 200);

    lcd.setCursor(0, posCursor); lcd.write(byte(0));

    if(!strcmp(bottone,"giu")) 
      MuoviCursore(&posCursor, 2, 'm');

    else if(!strcmp(bottone,"ok")||!strcmp(bottone,"incr")||!strcmp(bottone,"decr"))
      opcMenu = posCursor;
      
    if(a != 2)
      if(posCursor==2){
        lcd.clear();
        lcd.setCursor(2, 1);lcd.print("  g");  
        lcd.setCursor(1, 0); lcd.print(grammi);
        lcd.setCursor(1, 1); lcd.print("Back");
        lcd.setCursor(6, 0); lcd.print("ok");
        a=2;
        b=0;
      }
    
    if(posCursor != 2){
      a=posCursor;
      if(b !=2){
        lcd.clear();
        lcd.setCursor(1, 0); lcd.print("Imposta");
        lcd.setCursor(2, 1);lcd.print("  g");  
        lcd.setCursor(1, 1); lcd.print(grammi);
        lcd.setCursor(6, 1); lcd.print("ok");
        b=2;
       }
    }
  Serial.print(posCursor);
  unsigned long currentMillis = millis();
  if(currentMillis - previousMillis6 > interval6) 
  {
    previousMillis6 = currentMillis;   
    if(posCursor==0&&c==0){
      lcd.clear();
      lcd.setCursor(1, 0); lcd.print("Imposta");
      lcd.setCursor(2, 1);lcd.print("  g");  
      lcd.setCursor(1, 1); lcd.print(grammi);
      lcd.setCursor(6, 1); lcd.print("ok");
      c=1;
      }
     else if(posCursor==0&&c==1){
      lcd.clear();
      lcd.setCursor(1, 0); lcd.print("Imposta");
      lcd.setCursor(2, 1);lcd.print("  g");  
      lcd.setCursor(1, 1); lcd.print("  ");
      lcd.setCursor(6, 1); lcd.print("ok");
      c=0;
      }
  }
  switch( opcMenu )
      {
        case 0:       
          if(!strcmp(bottone,"incr"))   
        {
          grammi=grammi+10;
          if(grammi >= 510)
            grammi=grammi-10;
          lcd.setCursor(2, 1);lcd.print("  g");  
          lcd.setCursor(1, 1); lcd.print(grammi);
          lcd.setCursor(6, 1); lcd.print("ok");
        }
        else if( !strcmp(bottone,"decr") ) 
        {
          grammi=grammi-10;
          if (grammi <= 0)
            grammi=grammi+10;
          lcd.setCursor(2, 1);lcd.print("  g");  
          lcd.setCursor(1, 1); lcd.print(grammi);
          lcd.setCursor(6, 1); lcd.print("ok");
        }
       
        break;
        case 1:       
          if( !strcmp(bottone,"ok") )
          {
            byte Alto = highByte(grammi);
            byte Basso = lowByte(grammi);
            EEPROM.write(19, Alto);
            EEPROM.write(30, Basso);
            lcd.clear();
            salva();
            opcMenu = -1;
          }
        break;
        
        case 2:   
          if( !strcmp(bottone,"ok") )
          {    
            lcd.clear();
            opcMenu = -1;
          }
        break;
      };
    }while(opcMenu != -1);
  
}

void SetOra(int i)
{
  char bottone[8];
  int posCursor=0, opcMenu=-2; 
  int Ore=EEPROM.read(i+1);
  int Minuti=EEPROM.read(i+10);
  int flag=0,c=0;
  int NO=1,NM=10;
  
  lcd.clear();

  lcd.setCursor(2,0);
  stampa(Ore);
  lcd.setCursor(4,0);
  lcd.print(":");
  lcd.setCursor(5,0);
  stampa(Minuti);
  lcd.setCursor(2,1);
  lcd.print("ok");
    
  do{
    strcpy(bottone,"null");
    LeggiBottone( bottone, A2, 200);

    lcd.setCursor(0, posCursor); lcd.write(byte(0));

    if(!strcmp(bottone,"giu")) 
      MuoviCursore(&posCursor, 1, 'm');

    else if(!strcmp(bottone,"ok")||!strcmp(bottone,"incr")||!strcmp(bottone,"decr"))
      opcMenu = posCursor;

    unsigned long currentMillis = millis();
  if(currentMillis - previousMillis7 > interval7) 
  {
    previousMillis7 = currentMillis;   
    if(posCursor==0&&flag==0&&c==0){
      lcd.setCursor(2, 0); stampa(Ore);
      lcd.setCursor(5, 0); stampa(Minuti);
      c=1;
      }
    else if(posCursor==0&&flag==0&&c==1){
      lcd.setCursor(2, 0); lcd.print("  ");
      lcd.setCursor(5, 0); stampa(Minuti);
      c=0;
      }
    if(posCursor==0&&flag==1&&c==0){
      lcd.setCursor(2, 0); stampa(Ore);
      lcd.setCursor(5, 0); stampa(Minuti);
      c=1;
      }
    else if(posCursor==0&&flag==1&&c==1){
      lcd.setCursor(2, 0); stampa(Ore);
      lcd.setCursor(5, 0); lcd.print("  ");
      c=0;
      }
    }
    
    switch( opcMenu )
    {
      case 0:
        if(!strcmp(bottone,"incr"))   
        {
          if(flag==0){
          Ore=Ore+1;
          if(Ore>= 25)
            Ore--;
          lcd.setCursor(2, 0); stampa(Ore);
          }
          else{
              Minuti=Minuti+1;
            if(Minuti >= 60)
              Minuti--;
              lcd.setCursor(5, 0); stampa(Minuti);
          }
        }  
        else if( !strcmp(bottone,"decr") ) 
        {
          if(flag==0){
            Ore=Ore-1;
            if (Ore <= 0)
              Ore++;
            lcd.setCursor(2, 0); stampa(Ore);
          }
          else{
              Minuti=Minuti-1;
            if(Minuti <= 0 )
              Minuti++;
              lcd.setCursor(5, 0); stampa(Minuti);
          }
        }  
        else if(!strcmp(bottone,"ok"))
        {
          if(flag==0)
            flag=1;
          else
            flag=0; 
        }
        opcMenu = -2;
      break;

      case 1:
        if(!strcmp(bottone,"ok")){
          EEPROM.update(NO+i,Ore);
          EEPROM.update(NM+i,Minuti);
          opcMenu = -1;
          }
      break;
    };
  }while(opcMenu != -1);
  mem=1;
}

void salva(){
  lcd.clear();
  lcd.setCursor(2, 0); lcd.print("Dati");
  lcd.setCursor(0, 1); lcd.print("Salvati!");
  delay(1000);
  lcd.clear();
  }

